//IEBUPDTE JOB (001),'MVTCOBOL MACRO',CLASS=A,MSGCLASS=A                00010000
//IEBUPDTE EXEC PGM=IEBUPDTE,REGION=1024K,PARM=NEW                      00020000
//SYSUT2   DD  DISP=SHR,DSN=SYSP.MACLIB          <==TARGET LIBRARY      00030000
//SYSPRINT DD  SYSOUT=*                                                 00040000
//SYSIN    DD  *                                                        00050000
./ ADD NAME=MVTCOBOL 8004-76320-76320-2357-00260-00249-00000-JAY01
               MACRO                                                    00010000
         MVTCOBOL &BUF=,&CNDENSE=NOCLIST,&DATAMAP=NODMAP,&LIB=LIB,     100020000
               &LINECNT=60,&LITCHAR=APOST,&MSGLEV=FLAGW,               200030000
               &PROCMAP=NOPMAP,&PUNCH=NODECK,&REFLIST=NOXREF,          300040000
               &SEQCHK=SEQ,&SIZE=81920,&SORLIST=SOURCE,&SPACE=SPACE1,  400050000
               &SUPPRES=NOSUPMAP,&TRNCATE=NOTRUNC,&TYPERUN=LOAD,       500060000
               &VERB=VERB                                               00070000
.*--------------------------------------------------------------------* 00080000
.* THIS MACRO ACCEPTS THE SAME OPTIONS REQUIRED ON THE MVT SYSTEM     * 00090000
.* GENERATION =COBOL= MACRO. THE SAME VERIFICATION TESTS ARE USED AS  * 00100000
.* THOSE PERFORMED BY THE SYSGEN MACRO AND THE SAME MESSAGES WILL BE  * 00110000
.* PRODUCED (BOTH ERROR AND INFORMATIONAL). IF NO ERRORS ARE FOUND,   * 00120000
.* CARDS WILL BE PUNCHED THAT MAY BE FED INTO IMASPZAP THAT WILL      * 00130000
.* UPDATE THE MVT COBOL COMPILER LOAD MODULE =IKFCBL01= TO SET NEW    * 00140000
.* INSTALLATION DEFAULT OPTIONS.                                      * 00150000
.*                                                                    * 00160000
.* AUTHOR: JAY MOSELEY, CCP  (NOVEMBER, 2004)                         * 00170000
.*--------------------------------------------------------------------* 00180000
         LCLB  &TERMSW                                                  00190000
         LCLB  &OPTA(7),&OPTB(6),&OPTC(1),&SPCHAR(2)                    00200000
         LCLA  &SIZEVA,&BUFVA,&LCNTVA                                   00210000
         LCLC  &C                                                       00220000
.I1      AIF (T'&SIZE NE 'N').M1                                        00230000
         AIF (K'&SIZE GT 7 OR '&SIZE' LT '81920').M1                    00240000
         MNOTE *,'      &SIZE BYTES OF STORAGE AVAILABLE FOR COMPILER'  00250000
&SIZEVA  SETA &SIZE                                                     00260000
         AIF ('&BUF' NE '').I2                                          00270000
&BUFVA   SETA (&SIZE-81920)/4+2768                                      00280000
         AGO .I2X                                                       00290000
.I2      AIF (T'&BUF NE 'N').M2                                         00300000
         AIF (K'&BUF GT 7 OR '&BUF' LT '2768').M2                       00310000
&BUFVA   SETA &BUF                                                      00320000
.I2X     MNOTE *,'      &BUFVA BYTES OF STORAGE AVAILABLE FOR BUFFERS'  00330000
.I3      AIF ('&CNDENSE' NE 'CLIST' AND '&CNDENSE' NE 'NOCLIST').M3     00340000
&C       SETC ' NOT '(1,((K'&CNDENSE-5)*2+1))                           00350000
         MNOTE *,'      CONDENSED LISTING WILL&C.BE PRODUCED'           00360000
&OPTB(2) SETB ('&CNDENSE' EQ 'CLIST')                                   00370000
.I4      AIF (T'&DATAMAP EQ 'O' OR '&DATAMAP' EQ 'NODMAP').I4A          00380000
         AIF ('&DATAMAP' NE 'DMAP').M4                                  00390000
&OPTB(3) SETB 1                                                         00400000
&C       SETC ' '                                                       00410000
         AGO  .I4X                                                      00420000
.I4A     ANOP                                                           00430000
&C       SETC ' NOT '                                                   00440000
.I4X     MNOTE *,'      RELATIVE LOCATION MAP WILL&C.BE PRINTED'        00450000
.I5      AIF   (T'&LIB EQ 'O' OR '&LIB' EQ 'LIB').I5A                   00460000
         AIF   ('&LIB' NE 'NOLIB').M5                                   00470000
&C       SETC  ' NOT '                                                  00480000
         AGO   .I5X                                                     00490000
.I5A     ANOP                                                           00500000
&C       SETC  ' '                                                      00510000
&OPTA(7) SETB 1                                                         00520000
.I5X     MNOTE *,'      LIB OPTION WILL&C.BE INCLUDED'                  00530000
.I6      AIF   (T'&LINECNT NE 'N').M6                                   00540000
         AIF   (K'&LINECNT GT 2 OR &LINECNT LT 10).M6                   00550000
         MNOTE *,'      MAXIMUM &LINECNT LINES PER PAGE OF COMPILER OUTC00560000
               PUT'                                                     00570000
&LCNTVA  SETA  &LINECNT                                                 00580000
.I7      AIF ('&LITCHAR' NE 'QUOTE' AND '&LITCHAR' NE 'APOST').M7       00590000
         AIF ('&LITCHAR' EQ 'APOST').I7A                                00600000
         MNOTE *,'      QUOTES WILL BE USED TO DELINEATE LITERALS'      00610000
         AGO .I8                                                        00620000
.I7A     MNOTE *,'      APOSTROPHES WILL BE USED TO DELINEATE LITERALS' 00630000
&OPTB(4) SETB 1                                                         00640000
.I8      AIF ('&MSGLEV' NE 'FLAGW' AND '&MSGLEV' NE 'FLAGE').M8         00650000
         AIF ('&MSGLEV' NE 'FLAGW').I8A                                 00660000
         MNOTE *,'      ALL WARNING AND ERROR MESSAGES PRINTED'         00670000
&OPTA(6) SETB 1                                                         00680000
         AGO   .I9                                                      00690000
.I8A     MNOTE *,'      ONLY ERROR MESSAGES PRINTED'                    00700000
.I9      AIF (T'&PROCMAP EQ 'O' OR '&PROCMAP' EQ 'NOPMAP').I9A          00710000
         AIF ('&PROCMAP' NE 'PMAP').M9                                  00720000
&OPTA(2) SETB 1                                                         00730000
         AIF (&OPTA(2) AND &OPTB(2)).M19                                00740000
&C       SETC ' '                                                       00750000
         AGO .I9B                                                       00760000
.I9A     ANOP                                                           00770000
&C       SETC ' NOT '                                                   00780000
.I9B     MNOTE *,'      PROCEDURE MAP WILL&C.BE PRODUCED'               00790000
.I10     AIF ('&PUNCH' NE 'DECK' AND '&PUNCH' NE 'NODECK').M10          00800000
&C       SETC ' NOT '(1,((K'&PUNCH-4)*2+1))                             00810000
         MNOTE *,'      OBJECT DECK OF PROGRAM WILL&C.BE PUNCHED'       00820000
&OPTA(3) SETB ('&PUNCH' EQ 'DECK')                                      00830000
.I11     AIF ('&REFLIST' NE 'NOXREF' AND '&REFLIST' NE 'XREF').M11      00840000
&C       SETC ' NOT '(1,((K'&REFLIST-4)*2+1))                           00850000
         MNOTE *,'      CROSS REFERENCE LISTING WILL&C.BE PRODUCED'     00860000
&OPTB(1) SETB ('&REFLIST' EQ 'XREF')                                    00870000
.I12     AIF ('&SEQCHK' NE 'SEQ' AND '&SEQCHK' NE 'NOSEQ').M12          00880000
&C       SETC ' NOT '(1,((K'&SEQCHK-3)*2+1))                            00890000
         MNOTE *,'      CARD SEQUENCE OF PROGRAM WILL&C.BE CHECKED'     00900000
&OPTA(5) SETB ('&SEQCHK' EQ 'SEQ')                                      00910000
.I13     AIF ('&SORLIST' NE 'SOURCE' AND '&SORLIST' NE 'NOSOURCE').M13  00920000
&C       SETC ' NOT '(1,((K'&SORLIST-6)*2+1))                           00930000
         MNOTE *,'      SOURCE LISTING WILL&C.BE PRODUCED'              00940000
&OPTA(1) SETB ('&SORLIST' EQ 'SOURCE')                                  00950000
.I14     AIF ('&SPACE' NE 'SPACE1' AND '&SPACE' NE 'SPACE2' AND        C00960000
               '&SPACE' NE 'SPACE3').M14                                00970000
&C       SETC '&SPACE'(6,1)                                             00980000
         MNOTE *,'      LISTING WILL HAVE &C SPACES BETWEEN LINES'      00990000
&SPCHAR(1) SETB ('&SPACE' EQ 'SPACE2')                                  01000000
&SPCHAR(2) SETB ('&SPACE' EQ 'SPACE3')                                  01010000
.I15     AIF ('&SUPPRES' NE 'NOSUPMAP' AND '&SUPPRES' NE 'SUPMAP').M15  01020000
&C       SETC ' NOT '(1,((K'&SUPPRES-6)*2+1))                           01030000
         MNOTE *,'      OBJECT LISTING WILL&C.BE SUPPRESSED IF E-LEVEL' 01040000
         MNOTE *,'          MSG IS GENERATED'                           01050000
&OPTB(5) SETB ('&SUPPRES' EQ 'SUPMAP')                                  01060000
.I16     AIF ('&TRNCATE' NE 'TRUNC' AND '&TRNCATE' NE 'NOTRUNC').M16    01070000
         AIF ('&TRNCATE' EQ 'NOTRUNC').I16A                             01080000
         MNOTE *,'      BINARY ITEMS MOVED ACCORDING TO PICTURE CLAUSE' 01090000
         AGO .I16B                                                      01100000
.I16A    MNOTE *,'      BINARY ITEMS MOVED ACCORDING TO SIZE OF FIELD IC01110000
               N STORAGE'                                               01120000
.I16B    ANOP                                                           01130000
&OPTB(6) SETB ('&TRNCATE' EQ 'TRUNC')                                   01140000
.I17     AIF ('&TYPERUN' NE 'LOAD' AND '&TYPERUN' NE 'NOLOAD').M17      01150000
&C       SETC ' NOT '(1,((K'&TYPERUN-4)*2+1))                           01160000
         MNOTE *,'      COMPILED PROGRAM WILL&C.BE LINKAGE EDITED'      01170000
&OPTA(4) SETB ('&TYPERUN' EQ 'LOAD')                                    01180000
.I18     AIF   (T'&VERB EQ 'O' OR '&VERB' EQ 'VERB').I18A               01190000
         AIF   ('&VERB' NE 'NOVERB').M18                                01200000
&C       SETC  ' NOT '                                                  01210000
         AGO   .I18B                                                    01220000
.I18A    ANOP                                                           01230000
&C       SETC  ' '                                                      01240000
&OPTC(1) SETB 1                                                         01250000
.I18B    MNOTE *,'      VERB OPTION WILL&C.BE INCLUDED'                 01260000
.I19     AIF (NOT &TERMSW).GEN                                          01270000
         MNOTE 9,'* * * SYNTAX ERRORS PREVENT CONTINATION'              01280000
         AGO   .MEND                                                    01290000
.M1      MNOTE 5,'* * * SIZE VALUE &SIZE INVALID'                       01300000
&TERMSW  SETB  1                                                        01310000
         AGO   .I2                                                      01320000
.M2      MNOTE 5,'* * * BUF VALUE &BUF INVALID'                         01330000
&TERMSW  SETB  1                                                        01340000
         AGO   .I3                                                      01350000
.M3      MNOTE 5,'* * * CNDENSE VALUE &CNDENSE INVALID'                 01360000
&TERMSW  SETB  1                                                        01370000
         AGO   .I4                                                      01380000
.M4      MNOTE 5,'* * * DATAMAP VALUE &DATAMAP INVALID'                 01390000
&TERMSW  SETB  1                                                        01400000
         AGO   .I5                                                      01410000
.M5      MNOTE 5,'* * * LIB VALUE &LIB INVALID'                         01420000
&TERMSW  SETB  1                                                        01430000
         AGO   .I6                                                      01440000
.M6      MNOTE 5,'* * * LINECT VALUE &LINECNT INVALID'                  01450000
&TERMSW  SETB  1                                                        01460000
         AGO   .I7                                                      01470000
.M7      MNOTE 5,'* * * LITCHAR VALUE &LITCHAR INVALID'                 01480000
&TERMSW  SETB  1                                                        01490000
         AGO   .I8                                                      01500000
.M8      MNOTE 5,'* * * MSGLEV VALUE &MSGLEV INVALID'                   01510000
&TERMSW  SETB  1                                                        01520000
         AGO   .I9                                                      01530000
.M9      MNOTE 5,'* * * PROCMAP VALUE &PROCMAP INVALID'                 01540000
&TERMSW  SETB  1                                                        01550000
         AGO   .I10                                                     01560000
.M10     MNOTE 5,'* * * PUNCH VALUE &PUNCH INVALID'                     01570000
&TERMSW  SETB  1                                                        01580000
         AGO   .I11                                                     01590000
.M11     MNOTE 5,'* * * REFLIST VALUE &REFLIST INVALID'                 01600000
&TERMSW  SETB  1                                                        01610000
         AGO   .I12                                                     01620000
.M12     MNOTE 5,'* * * SEQCHK VALUE &SEQCHK INVALID'                   01630000
&TERMSW  SETB  1                                                        01640000
         AGO   .I13                                                     01650000
.M13     MNOTE 5,'* * * SORLIST VALUE &SORLIST INVALID'                 01660000
&TERMSW  SETB  1                                                        01670000
         AGO   .I14                                                     01680000
.M14     MNOTE 5,'* * * SPACE VALUE &SPACE INVALID'                     01690000
&TERMSW  SETB  1                                                        01700000
         AGO   .I15                                                     01710000
.M15     MNOTE 5,'* * * SUPPRES VALUE &SUPPRES INVALID'                 01720000
&TERMSW  SETB  1                                                        01730000
         AGO   .I16                                                     01740000
.M16     MNOTE 5,'* * * TRNCATE VALUE &TRNCATE INVALID'                 01750000
&TERMSW  SETB  1                                                        01760000
         AGO   .I17                                                     01770000
.M17     MNOTE 5,'* * * TYPERUN VALUE &TYPERUN INVALID'                 01780000
&TERMSW  SETB  1                                                        01790000
         AGO   .I18                                                     01800000
.M18     MNOTE 5,'* * * VERB VALUE &VERB INVALID'                       01810000
&TERMSW  SETB  1                                                        01820000
         AGO   .I19                                                     01830000
.M19     MNOTE 5,'* * * PMAP AND CLIST MUTUALLY EXCUSIVE'               01840000
&TERMSW  SETB  1                                                        01850000
         AGO   .I10                                                     01860000
.GEN     ANOP                          GENERATE IMASPZAP CARDS          01870000
         PUNCH 'NAME IKFCBL01 IKFCBL01 '                                01880000
         LCLA  &OPTV                                                    01890000
         LCLC  &OPTE                                                    01900000
.*                                    CONVERT 1ST OPTION BYTE TO HEX    01910000
&OPTV    SETA  &OPTA(1)                                                 01920000
&OPTV    SETA  (&OPTV*2)+&OPTA(2)                                       01930000
&OPTV    SETA  (&OPTV*2)+&OPTA(3)                                       01940000
&OPTV    SETA  (&OPTV*2)+&OPTA(4)                                       01950000
&OPTE    SETC  '0123456789ABCDEF'(&OPTV+1,1)                            01960000
&OPTV    SETA  &OPTA(5)                                                 01970000
&OPTV    SETA  (&OPTV*2)+&OPTA(6)                                       01980000
&OPTV    SETA  (&OPTV*2)+&OPTA(7)                                       01990000
&OPTV    SETA  (&OPTV*2)+1                                              02000000
&OPTE    SETC  '&OPTE'.'0123456789ABCDEF'(&OPTV+1,1)                    02010000
         PUNCH 'REP 0302 &OPTE '                                        02020000
.*                                    CONVERT 2ND OPTION BYTE TO HEX    02030000
&OPTV    SETA  &OPTB(1)                                                 02040000
&OPTV    SETA  (&OPTV*2)+&OPTB(2)                                       02050000
&OPTV    SETA  (&OPTV*2)+&OPTB(3)                                       02060000
&OPTV    SETA  &OPTV*2                                                  02070000
&OPTE    SETC  '0123456789ABCDEF'(&OPTV+1,1)                            02080000
&OPTV    SETA  &OPTB(4)                                                 02090000
&OPTV    SETA  (&OPTV*2)+&OPTB(5)                                       02100000
&OPTV    SETA  (&OPTV*2)+&OPTB(6)                                       02110000
&OPTE    SETC  '&OPTE'.'0123456789ABCDEF'(&OPTV+1,1)                    02120000
         PUNCH 'REP 0303 &OPTE '                                        02130000
.*                                    CONVERT 3RD OPTION BYTE TO HEX    02140000
&OPTE    SETC  '0'.'01'(&OPTC(1)+1,1)                                   02150000
         PUNCH 'REP 0304 &OPTE '                                        02160000
.*                                    CONVERT SIZE TO BASE 16           02170000
         LCLA  &Q,&R                                                    02180000
         LCLC  &SZEBC                                                   02190000
.S1      ANOP                                                           02200000
&Q       SETA  &SIZEVA/16                                               02210000
&R       SETA  &SIZEVA-(&Q*16)                                          02220000
&SZEBC   SETC  '0123456789ABCDEF'(&R+1,1).'&SZEBC'                      02230000
&SIZEVA  SETA  &Q                                                       02240000
         AIF   ('&Q' NE '0').S1                                         02250000
.S2      AIF   (K'&SZEBC EQ 8).S3                                       02260000
&SZEBC   SETC  '0'.'&SZEBC'                                             02270000
         AGO   .S2                                                      02280000
.S3      PUNCH 'REP 0388 &SZEBC '                                       02290000
.*                                    CONVERT BUF TO BASE 16            02300000
         LCLC  &BFEBC                                                   02310000
.B1      ANOP                                                           02320000
&Q       SETA  &BUFVA/16                                                02330000
&R       SETA  &BUFVA-(&Q*16)                                           02340000
&BFEBC   SETC  '0123456789ABCDEF'(&R+1,1).'&BFEBC'                      02350000
&BUFVA   SETA  &Q                                                       02360000
         AIF   ('&Q' NE '0').B1                                         02370000
.B2      AIF   (K'&BFEBC EQ 8).B3                                       02380000
&BFEBC   SETC  '0'.'&BFEBC'                                             02390000
         AGO   .B2                                                      02400000
.B3      PUNCH 'REP 038C &BFEBC '                                       02410000
.*                                    CONVERT LINE COUNT TO HEX         02420000
         LCLC  &LCEBC                                                   02430000
&LCEBC   SETC  '0'                                                      02440000
&Q       SETA  &LCNTVA/10                                               02450000
&R       SETA  &LCNTVA-(&Q*10)                                          02460000
&LCEBC   SETC  '&LCEBC'.'0123456789'(&Q+1,1)                            02470000
&LCEBC   SETC  '&LCEBC'.'0123456789'(&R+1,1).'C'                        02480000
         PUNCH 'REP 0390 &LCEBC '                                       02490000
.*                                    CONVERT SPACE TO HEX              02500000
         LCLC  &SPEBC                                                   02510000
&SPEBC   SETC  '40'                   BLANK = SINGLE                    02520000
         AIF   ('&SPCHAR(2)' NE '1').SP2                                02530000
&SPEBC   SETC  '60'                   - = TRIPLE                        02540000
.SP2     AIF   ('&SPCHAR(1)' NE '1').SPX                                02550000
&SPEBC   SETC  'F0'                   0 = DOUBLE                        02560000
.SPX     PUNCH 'REP 0392 &SPEBC '                                       02570000
         PUNCH 'NAME IKFCBL01 IKF011 '                                  02580000
         PUNCH 'REP 0598 &BFEBC '                                       02590000
.MEND    MEND                                                           02600000
./ ENDUP       "REVIEW" PDS MEMBER OFFLOAD AT 09:48 ON 76/11/16
//                                                                      00090000
